<?php
/**
 * @package Scheduler
 * @author DHTMLX LTD
 * @version 2.0
 */
/*
Plugin Name: Event Calendar / Scheduler
Plugin URI: http://wordpress.org/extend/plugins/event-calendar-scheduler/
Description: Events calendar that provides rich and intuitive scheduling solution
Author: DHTMLX LTD
Version: 2.0
Author URI: http://dhtmlx.com
*/


global $lang;
$lang = array();
$lang['Scheduler'] = 'Scheduler';

global $wpdb;
add_option('scheduler_php', '');
add_option('scheduler_xml', '<config><active_tab>a1</active_tab><settings><settings_width>680px</settings_width><settings_height>600px</settings_height><settings_eventnumber>2</settings_eventnumber><settings_link></settings_link><settings_posts>false</settings_posts><settings_repeat>true</settings_repeat><settings_firstday>false</settings_firstday><settings_multiday>true</settings_multiday><settings_singleclick>false</settings_singleclick><settings_day>true</settings_day><settings_week>true</settings_week><settings_month>true</settings_month><settings_agenda>false</settings_agenda><settings_year>false</settings_year><settings_defaultmode>month</settings_defaultmode><settings_debug>false</settings_debug><settings_eventnumber>2</settings_eventnumber><settings_collision>false</settings_collision><settings_expand>true</settings_expand><settings_print>false</settings_print><settings_minical>false</settings_minical></settings><access><access_guestView>true</access_guestView><access_guestAdd>false</access_guestAdd><access_guestEdit>false</access_guestEdit><access_subscriberView>true</access_subscriberView><access_subscriberAdd>false</access_subscriberAdd><access_subscriberEdit>false</access_subscriberEdit><access_contributorView>true</access_contributorView><access_contributorAdd>false</access_contributorAdd><access_contributorEdit>false</access_contributorEdit><access_authorView>true</access_authorView><access_authorAdd>false</access_authorAdd><access_authorEdit>false</access_authorEdit><access_editorView>true</access_editorView><access_editorAdd>true</access_editorAdd><access_editorEdit>true</access_editorEdit><access_administratorView>true</access_administratorView><access_administratorAdd>true</access_administratorAdd><access_administratorEdit>true</access_administratorEdit></access><templates><templates_defaultdate><![CDATA[%d %M %Y]]></templates_defaultdate><templates_monthdate><![CDATA[%F %Y]]></templates_monthdate><templates_weekdate><![CDATA[%D, %F %d]]></templates_weekdate><templates_daydate><![CDATA[%d/%m/%Y]]></templates_daydate><templates_hourdate><![CDATA[%H:%i]]></templates_hourdate><templates_monthday><![CDATA[%d]]></templates_monthday><templates_minmin><![CDATA[5]]></templates_minmin><templates_hourheight><![CDATA[40]]></templates_hourheight><templates_starthour><![CDATA[0]]></templates_starthour><templates_endhour><![CDATA[24]]></templates_endhour><templates_eventtext><![CDATA[return event.text;]]></templates_eventtext><templates_eventheader><![CDATA[return scheduler.templates.hour_scale(start) + " - " + scheduler.templates.hour_scale(end);]]></templates_eventheader><templates_eventbartext><![CDATA[return "<span title=\'"+event.text+"\'>" + event.text + "</span>";]]></templates_eventbartext></templates><customfields><customfield name="Text" dsc="Description" type="textarea" old_name="Text" use_colors="false" units="false" height="150" /></customfields></config>');
add_option('scheduler_php_version', '0');
add_option('scheduler_xml_version', '1');
add_option('scheduler_url', '');
add_option('scheduler_num', '5');
add_option('scheduler_started', '0');
//add_option('scheduler_version', '2.0');

require_once(WP_PLUGIN_DIR.'/event-calendar-scheduler/codebase/dhtmlxSchedulerConfigurator.php');
require_once(WP_PLUGIN_DIR.'/event-calendar-scheduler/SchedulerHelper.php');
$usertypes = Array(0 => 'subscriber', 1 => 'contributor', 2 => 'author', 3 => 'editor', 4 => 'editor', 5 => 'editor', 6 => 'editor', 7 => 'editor', 8 => 'administrator', 9 => 'administrator', 10 =>'administrator');
$table = 'options';
$table_name = 'events_rec';
$fieldName = 'option_name';
$fieldValue = 'option_value';
if (isset($wpdb->base_prefix)) {
	$prefix = $wpdb->base_prefix;
} else {
	$prefix = $wpdb->prefix;
}


if (get_option('scheduler_started') == '0') {
		$sql = "CREATE TABLE IF NOT EXISTS `".$prefix.$table_name."` (
		`event_id` int(11) NOT NULL AUTO_INCREMENT,
		`start_date` datetime NOT NULL,
		`end_date` datetime NOT NULL,
		`text` varchar(255) NOT NULL,
		`rec_type` varchar(64) NOT NULL,
		`event_pid` int(11) NOT NULL,
		`event_length` int(11) NOT NULL,
		PRIMARY KEY (`event_id`)
		) ENGINE=MyISAM  DEFAULT CHARSET=utf8 AUTO_INCREMENT=1 ;";

		$result = $wpdb->query($sql);
		$insert = "INSERT INTO ".$prefix.$table_name.
			" (`start_date`, `end_date`, `text`, `event_pid`, `event_length`) VALUES ".
			"(NOW(), DATE_ADD(NOW(), INTERVAL 5 MINUTE), 'The Scheduler Calendar was installed!', 0, 0);";
		$wpdb->query($insert);

	update_option('scheduler_started', '1');
}

$cfg = new SchedulerConfig('scheduler_config_xml', $wpdb->dbh, $table, $fieldName, $fieldValue, $table_name, $prefix);


$version = get_option('scheduler_version');
if (($version !== false)&&((int) $version < 2)) {
	include('settings_export.php');
	update_option('scheduler_version', '2.0');
} else {
	add_option('scheduler_version', '2.0');
}



add_action('admin_init', 'scheduler_admin_init');
function scheduler_admin_init(){
	register_setting('scheduler_options', 'scheduler_xml');
	register_setting('scheduler_options', 'scheduler_xml_version');
}

if (get_option('scheduler_version') != '2.0') {
	$sql = "RENAME TABLE `".get_option('scheduler_table_name')."`  TO `".$prefix.$table_name."` ;";
	$wpdb->query($sql);

	$query = "ALTER TABLE `".$prefix.$table_name."` CHANGE `text` `text` VARCHAR( 255 ) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL ;";
	$wpdb->query($query);
	$query = "ALTER TABLE `".$prefix.$table_name."` CHANGE `rec_type` `rec_type` VARCHAR( 64 ) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL  ;";
	$wpdb->query($query);
	$query = "ALTER TABLE `".$prefix.$table_name."`  DEFAULT CHARACTER SET utf8 COLLATE utf8_general_ci;";
	$wpdb->query($query);
	update_option('scheduler_version', '2.0');
}

if ($cfg->get_option('settings_link') == '') {
	$url_query = "SELECT `guid` FROM `".$prefix."posts` WHERE `post_title`='scheduler-calendar'";
	$url = $wpdb->get_var($url_query);

	if (!$url) {
		$page_number = "SELECT MAX(`ID`) FROM `".$prefix."posts`";
		$page_number = $wpdb->get_var($page_number);
		$insert = "INSERT INTO `".$prefix."posts` (`ID`, `post_author`, `post_date`, `post_date_gmt`, `post_content`, `post_title`, `post_excerpt`, `post_status`, `comment_status`, `ping_status`, `post_password`, `post_name`, `to_ping`, `pinged`, `post_modified`, `post_modified_gmt`, `post_content_filtered`, `post_parent`, `guid`, `menu_order`, `post_type`, `post_mime_type`, `comment_count`) VALUES
				(".($page_number + 1).", 1, '".date("Y-m-d H:i:s")."', '0000-00-00 00:00:00', '[[scheduler_plugin]]', 'scheduler-calendar', '', 'publish', 'closed', 'closed', '', '', '', '', '".date("Y-m-d H:i:s")."', '".date("Y-m-d H:i:s")."', '', 0, '".get_option('siteurl')."/?page_id=".($page_number+1)."', 0, 'page', '', 0)";
		$wpdb->query($insert);
	}
	$url_query = "SELECT `guid` FROM `".$prefix."posts` WHERE `post_title`='scheduler-calendar'";
	$url = $wpdb->get_var($url_query);
	$cfg->set_option('settings_link', $url);
}

$locale = WPLANG;
$loc = substr($locale, 0, 2);
load_plugin_textdomain('scheduler', PLUGINDIR.'/'.dirname(plugin_basename(__FILE__)).'/codebase/sources', dirname(plugin_basename(__FILE__)).'/codebase/sources');


function scheduler_add_pages() {
	global $lang;
	add_submenu_page('plugins.php', __('Scheduler', 'scheduler'), __('Scheduler', 'scheduler'), 'administrator', __FILE__, 'scheduler_settings');
}


function scheduler_settings() {
	global $lang, $current_user, $cfg, $loc;
	include(ABSPATH.'wp-content/plugins/event-calendar-scheduler/admin.php');
}


function scheduler_init() {
	global $usertypes, $current_user, $user_ID, $cfg, $loc;
	if (isset($current_user->roles[0])) {
		$usertype = $current_user->roles[0];
	} else {
		$usertype = 'guest';
	}
	$url = WP_PLUGIN_URL.'/event-calendar-scheduler/codebase/';
	$final = $cfg->schedulerInit($usertype, $loc, $url);
	return $final;
}


function get_events($number = 5) {
	global $wpdb, $prefix;

	$start = date('Y-m-d H:i:s');
	$endd = date('Y-m-d H:i:s', time() + 60*60*24*30*3);

	$dates = new SchedulerHelper($wpdb->dbh, $prefix.'events_rec');
	$events = $dates->get_dates($start, $endd);
	
	$repeat = true;
	while ($repeat == true) {
		$repeat = false;
		for ($i = 0; $i < count($events) - 1; $i++) {
			if ($events[$i]['start_date'] > $events[$i + 1]['start_date']) {
				$ev = $events[$i];
				$events[$i] = $events[$i + 1];
				$events[$i + 1] = $ev;
				$repeat = true;
			}
		}
	}
	if ($number < count($events)) {
		array_splice(&$events, $number);
	}
	return $events;
}


function scheduler_sidebar() {
	global $wpdb, $prefix, $table_name, $lang, $usertypes, $current_user, $user_ID, $cfg;
	
	$usertype = $current_user->user_level;
	if (isset($usertypes[$usertype])) {
		$usertype = $usertypes[$usertype];
	} else {
		$usertype = 'guest';
	}

	if ($cfg->get_option("access_".$usertype."View") != 'true') {
		return '';
	}

	include(WP_PLUGIN_DIR.'/event-calendar-scheduler/sidebar.php');
	$number = $cfg->get_option('settings_eventnumber');
	if ($number == '') {
		$number = 5;
	}

	$events = get_events($number);
	
	$final = '<ul>';
	if (count($events) == 0) {
		$final = '';
	}

	$url = $cfg->get_option('settings_link');
	
	for ($i = 0; $i < count($events); $i++) {
		$event = $sidebarEvent;
		$start_date = str_replace("-", "/", $events[$i]['start_date']);
		$start_date = date_parse($events[$i]['start_date']);
		$start_date = mktime($start_date['hour'], $start_date['minute'], $start_date['second'], $start_date['month'], $start_date['day'], $start_date['year']);
		$start_date = date_i18n(get_option('date_format').' '.get_option('time_format'), $start_date);

		$event = str_replace("{*URL*}", $url, $event);
		$event = str_replace("{*DATE*}", $start_date, $event);
		$event = str_replace("{*DATE_SQL*}", $events[$i]['start_date'], $event);
		$event = str_replace("{*TEXT*}", stripslashes($events[$i]['text']), $event);
		$final .= $event;
	}
	$final .= '</ul>';
	return $final;
}


function scheduler_check($content) {
	global $lang;
	$ver = phpversion();
	$ver_main = (int) substr($ver, 0, 1);
	if ( $ver_main < 5) {
		return __('Installation error: Event Calendar / Scheduler plugin requires PHP 5.x', 'scheduler');
		}

	if (strpos($content, "[[scheduler_plugin]]") !== FALSE)  {
		$content = preg_replace('/<p>\s*\[\[(.*)\]\]\s*<\/p>/i', "[[$1]]", $content);
		$content = preg_replace('/\[\[scheduler_plugin\]\]/Ui', scheduler_init(), $content, 1);
		$content = str_replace('[[scheduler_plugin]]', '', $content);
	}
	if (strpos($content, "[[scheduler_sidebar]]")) {
		$content = preg_replace('/<p>\s*\[\[(.*)\]\]\s*<\/p>/i', "[[$1]]", $content);
		$content = str_replace('[[scheduler_sidebar]]', scheduler_sidebar(), $content);
	}
	return $content;
}


function scheduler_addbuttons() {
	global $current_user, $usertypes, $cfg;
	get_currentuserinfo();
	$usertype = $current_user->user_level;

	if (isset($usertypes[$usertype])) {
		$usertype = $usertypes[$usertype];
	} else {
		$usertype = 'guest';
	}

	if ((!current_user_can('edit_posts') && ! current_user_can('edit_pages'))||($cfg->get_option("access_".$usertype."Add") != 'true')) {
		return;
	}

	if (get_user_option('rich_editing') == 'true') {
		add_filter("mce_external_plugins", "add_scheduler_tinymce_plugin");
		add_filter('mce_buttons', 'register_scheduler_button');
	}
}


function register_scheduler_button($buttons) {
	array_push($buttons, "separator", "scheduler");
	return $buttons;
}


function add_scheduler_tinymce_plugin($plugin_array) {
	$plugin_array['scheduler'] = WP_PLUGIN_URL.'/event-calendar-scheduler/mce_scheduler/editor_plugin.js';
	return $plugin_array;
}

function upcoming_widget($args) {
    extract($args);
	echo $before_widget;
	echo $before_title;
	echo __('Oncoming events', 'scheduler');
	echo $after_title;
	echo scheduler_sidebar();
	echo $after_widget;
}

wp_register_sidebar_widget('upcoming_events', 'Upcoming Events', 'upcoming_widget');
add_action('admin_menu', 'scheduler_add_pages');
add_action('init', 'scheduler_addbuttons');
add_filter('the_content', 'scheduler_check');



?>